//---------------------------------------------------------------------------

//	#include <vcl\condefs.h>
#include <windows.h>
#include <iostream.h>
#include <stdio.h>
#include <stdlib.h>
#include <shellapi.h>
#include <string.h>
//  #include <dos.h>
#pragma hdrstop

// xmouse.cpp : Set X-ish focus policy.
//
/*
Many thanks to Josh Baudhuin <joshb@cadence.com>
found on microsoft.public.win2000.beta.user_interface 
xmouse [/on[:<timeout>] | /off] [/raise | /noraise]
w/ no args it displays the current settings
<timeout> is the time in milliseconds that the cursor has 
to be in a window before focus changes;
/raise causes the window to be brought to the front. 

llornkcor@llornkcor.com 
*/

#include <stdio.h>
#include <winuser.h>
bool help();
bool checkOSVersion();

//#ifdef WINVER >= 0x0400
//#define WINVER >= 0x0500 
//#endif 

int main(int argc, char* argv[])
{
        BOOL bTracking;
    if( checkOSVersion() )
    {
        SystemParametersInfo( SPI_GETACTIVEWINDOWTRACKING, 0, &bTracking, 0 );
        DWORD dwTrkTimeout;
        SystemParametersInfo( SPI_GETACTIVEWNDTRKTIMEOUT, 0, &dwTrkTimeout, 0 );
        BOOL bRaise;
        SystemParametersInfo( SPI_GETACTIVEWNDTRKZORDER, 0,  &bRaise, 0 );
        if (argc > 1)
        {
            for (int i = 1; i < argc; i++)
            {
                const UINT SPIFFLAGS = SPIF_SENDCHANGE | SPIF_UPDATEINIFILE;    
                if ( strnicmp(argv[i], "/on", 3)==0 )
                {
                    if ( !bTracking )
                        bTracking = SystemParametersInfo(  SPI_SETACTIVEWINDOWTRACKING,  0, (PVOID) TRUE,  SPIFFLAGS );
                    if ( argv[i][3]=='=' || argv[i][3]==':' )
                    {
                        dwTrkTimeout = (DWORD) atol(argv[i] + 4);
                        if (dwTrkTimeout < 2000)
                            bTracking |= SystemParametersInfo(  SPI_SETACTIVEWNDTRKTIMEOUT, 0, (PVOID) dwTrkTimeout, SPIFFLAGS );
                    }
                } 
                else if ( stricmp(argv[i], "/off")==0 )
                {
                    if ( bTracking )
                        bTracking =   SystemParametersInfo( SPI_SETACTIVEWINDOWTRACKING,0, (PVOID) FALSE,  SPIFFLAGS );
                }
                else if ( stricmp(argv[i], "/raise")==0 )
                {
                    if ( !bRaise )
                        SystemParametersInfo( SPI_SETACTIVEWNDTRKZORDER, 0, (PVOID) TRUE, SPIFFLAGS );
                }
                else if ( stricmp(argv[i], "/noraise")==0 )
                {
                    if ( bRaise )
                        SystemParametersInfo( SPI_SETACTIVEWNDTRKZORDER, 0, (PVOID) FALSE, SPIFFLAGS );
                }
                else if ( stricmp(argv[i], "/?")==0 )
                {
                    help();
                }
            }
            bTracking =NULL;//!main(1, argv);
        }
        else
        {
            printf( "xmouse: Active Window Tracking is %s.\n",bTracking? "on" : "off" );
            printf( "xmouse: ... Timeout is %d ms.\n", dwTrkTimeout );
            printf( "xmouse: An activated window %s be brought to the top.\n",     bRaise? "WILL" : "will NOT" );
            printf( "xmouse /? for help with command line arguments.\n");   
        }
    }
 
    return !bTracking;
}

bool help()
{
        printf( "xmouse examples usage:\n");
        printf( "xmouse /on:520 /raise\n");
        printf( "xmouse \[\/on[:<timeout>] | /off] [/raise | /noraise]\n"); 
        printf( "<timeout> is the time in milliseconds that the cursor has\n");
        printf( "to be in a window before focus changes;");
        printf( "\n/raise causes the window to be brought to the front.\n");       
        
    return true;	
}	

bool checkOSVersion()
{
	char *sMsg = "This version of xmouse requires Windows 98, or Windows 2000\n";

    OSVERSIONINFO osvi;
    osvi.dwOSVersionInfoSize = sizeof(OSVERSIONINFO);
      if (! GetVersionEx ( (OSVERSIONINFO *) &osvi) ) 
          {
          printf( "Error getting OS version information: %d\n", GetLastError() );
         return false;
          }
   switch (osvi.dwPlatformId)
   {
      case VER_PLATFORM_WIN32_NT:
         if ( osvi.dwMajorVersion <= 4 ) // if not Windows 2000
             {
             printf(sMsg);
             return false;
             }
         break;

      case VER_PLATFORM_WIN32_WINDOWS:
         if ((osvi.dwMajorVersion == 4) && (osvi.dwMinorVersion == 0)) // if not Windows 98
             {
             printf(sMsg);
             return false;
             }
         break;

      case VER_PLATFORM_WIN32s: // if window 3.1
          if ( osvi.dwMajorVersion <= 4 ) // if not Windows 2000
          {
              printf(sMsg);
              return false;
          }
          break;
   };
return true;	
}
